diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/misc.php ./wordpress-3.3/wp-admin/includes/misc.php
*** ./wordpress-3.2.1/wp-admin/includes/misc.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/misc.php	2011-12-10 12:26:48.000000000 -0600
***************
*** 223,232 ****
  function url_shorten( $url ) {
  	$short_url = str_replace( 'http://', '', stripslashes( $url ));
  	$short_url = str_replace( 'www.', '', $short_url );
! 	if ('/' == substr( $short_url, -1 ))
! 		$short_url = substr( $short_url, 0, -1 );
  	if ( strlen( $short_url ) > 35 )
! 		$short_url = substr( $short_url, 0, 32 ).'...';
  	return $short_url;
  }
  
--- 223,231 ----
  function url_shorten( $url ) {
  	$short_url = str_replace( 'http://', '', stripslashes( $url ));
  	$short_url = str_replace( 'www.', '', $short_url );
! 	$short_url = untrailingslashit( $short_url );
  	if ( strlen( $short_url ) > 35 )
! 		$short_url = substr( $short_url, 0, 32 ) . '...';
  	return $short_url;
  }
  
***************
*** 368,374 ****
  		}
  
  		update_user_meta($user->ID, $option, $value);
! 		wp_redirect( remove_query_arg( array('pagenum', 'apage', 'paged'), wp_get_referer() ) );
  		exit;
  	}
  }
--- 367,373 ----
  		}
  
  		update_user_meta($user->ID, $option, $value);
! 		wp_safe_redirect( remove_query_arg( array('pagenum', 'apage', 'paged'), wp_get_referer() ) );
  		exit;
  	}
  }
***************
*** 585,588 ****
  </fieldset>
  <?php
  }
! ?>
--- 584,595 ----
  </fieldset>
  <?php
  }
! 
! function _ipad_meta() {
! 	if ( strpos($_SERVER['HTTP_USER_AGENT'], 'iPad') !== false ) { ?>
! 		<meta name="viewport" id="ipad-viewportmeta" content="width=device-width, initial-scale=1">
! 	<?php
! 	}
! }
! add_action('admin_head', '_ipad_meta');
! 
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/ms.php ./wordpress-3.3/wp-admin/includes/ms.php
*** ./wordpress-3.2.1/wp-admin/includes/ms.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/ms.php	2011-11-16 16:02:01.000000000 -0600
***************
*** 53,68 ****
   * @return void
   */
  function wpmu_delete_blog( $blog_id, $drop = false ) {
! 	global $wpdb;
  
  	$switch = false;
  	if ( $blog_id != $wpdb->blogid ) {
  		$switch = true;
  		switch_to_blog( $blog_id );
  	}
  
- 	$blog_prefix = $wpdb->get_blog_prefix( $blog_id );
- 
  	do_action( 'delete_blog', $blog_id, $drop );
  
  	$users = get_users( array( 'blog_id' => $blog_id, 'fields' => 'ids' ) );
--- 53,69 ----
   * @return void
   */
  function wpmu_delete_blog( $blog_id, $drop = false ) {
! 	global $wpdb, $current_site;
  
  	$switch = false;
  	if ( $blog_id != $wpdb->blogid ) {
  		$switch = true;
  		switch_to_blog( $blog_id );
+ 		$blog = get_blog_details( $blog_id );
+ 	} else {
+ 		$blog = $GLOBALS['current_blog'];
  	}
  
  	do_action( 'delete_blog', $blog_id, $drop );
  
  	$users = get_users( array( 'blog_id' => $blog_id, 'fields' => 'ids' ) );
***************
*** 70,92 ****
  	// Remove users from this blog.
  	if ( ! empty( $users ) ) {
  		foreach ( $users as $user_id ) {
! 			remove_user_from_blog( $user_id, $blog_id) ;
  		}
  	}
  
  	update_blog_status( $blog_id, 'deleted', 1 );
  
  	if ( $drop ) {
- 		if ( substr( $blog_prefix, -1 ) == '_' )
- 			$blog_prefix =  substr( $blog_prefix, 0, -1 ) . '\_';
  
! 		$drop_tables = $wpdb->get_results( "SHOW TABLES LIKE '{$blog_prefix}%'", ARRAY_A );
! 		$drop_tables = apply_filters( 'wpmu_drop_tables', $drop_tables );
  
! 		reset( $drop_tables );
! 		foreach ( (array) $drop_tables as $drop_table) {
! 			$wpdb->query( "DROP TABLE IF EXISTS ". current( $drop_table ) ."" );
  		}
  		$wpdb->query( $wpdb->prepare( "DELETE FROM $wpdb->blogs WHERE blog_id = %d", $blog_id ) );
  		$dir = apply_filters( 'wpmu_delete_blog_upload_dir', WP_CONTENT_DIR . "/blogs.dir/{$blog_id}/files/", $blog_id );
  		$dir = rtrim( $dir, DIRECTORY_SEPARATOR );
--- 71,94 ----
  	// Remove users from this blog.
  	if ( ! empty( $users ) ) {
  		foreach ( $users as $user_id ) {
! 			remove_user_from_blog( $user_id, $blog_id );
  		}
  	}
  
  	update_blog_status( $blog_id, 'deleted', 1 );
  
+ 	// Don't destroy the initial, main, or root blog.
+ 	if ( $drop && ( 1 == $blog_id || is_main_site( $blog_id ) || ( $blog->path == $current_site->path && $blog->domain == $current_site->domain ) ) )
+ 		$drop = false;
+ 
  	if ( $drop ) {
  
! 		$drop_tables = apply_filters( 'wpmu_drop_tables', $wpdb->tables( 'blog' ) );
  
! 		foreach ( (array) $drop_tables as $table ) {
! 			$wpdb->query( "DROP TABLE IF EXISTS `$table`" );
  		}
+ 
  		$wpdb->query( $wpdb->prepare( "DELETE FROM $wpdb->blogs WHERE blog_id = %d", $blog_id ) );
  		$dir = apply_filters( 'wpmu_delete_blog_upload_dir', WP_CONTENT_DIR . "/blogs.dir/{$blog_id}/files/", $blog_id );
  		$dir = rtrim( $dir, DIRECTORY_SEPARATOR );
***************
*** 120,136 ****
  		}
  	}
  
! 	$wpdb->query( "DELETE FROM {$wpdb->usermeta} WHERE meta_key = '{$blog_prefix}autosave_draft_ids'" );
! 	$blogs = get_site_option( 'blog_list' );
! 	if ( is_array( $blogs ) ) {
! 		foreach ( $blogs as $n => $blog ) {
! 			if ( $blog['blog_id'] == $blog_id )
! 				unset( $blogs[$n] );
! 		}
! 		update_site_option( 'blog_list', $blogs );
! 	}
! 
! 	if ( $switch === true )
  		restore_current_blog();
  }
  
--- 122,128 ----
  		}
  	}
  
! 	if ( $switch )
  		restore_current_blog();
  }
  
***************
*** 250,256 ****
  	if ( ! is_object($errors) )
  		$errors = new WP_Error();
  
! 	if ( $current_user->id != $_POST['user_id'] )
  		return false;
  
  	if ( $current_user->user_email != $_POST['email'] ) {
--- 242,248 ----
  	if ( ! is_object($errors) )
  		$errors = new WP_Error();
  
! 	if ( $current_user->ID != $_POST['user_id'] )
  		return false;
  
  	if ( $current_user->user_email != $_POST['email'] ) {
***************
*** 393,399 ****
   */
  function get_space_allowed() {
  	$space_allowed = get_option( 'blog_upload_space' );
! 	if ( $space_allowed == false )
  		$space_allowed = get_site_option( 'blog_upload_space' );
  	if ( empty( $space_allowed ) || !is_numeric( $space_allowed ) )
  		$space_allowed = 50;
--- 385,391 ----
   */
  function get_space_allowed() {
  	$space_allowed = get_option( 'blog_upload_space' );
! 	if ( $space_allowed === false )
  		$space_allowed = get_site_option( 'blog_upload_space' );
  	if ( empty( $space_allowed ) || !is_numeric( $space_allowed ) )
  		$space_allowed = 50;
***************
*** 775,778 ****
--- 767,789 ----
  <?php
  }
  
+ /**
+  * Whether or not we have a large network.
+  *
+  * The default criteria for a large network is either more than 10,000 users or more than 10,000 sites.
+  * Plugins can alter this criteria  using the 'wp_is_large_network' filter.
+  *
+  * @since 3.3.0
+  * @param string $using 'sites or 'users'.  Default is 'sites'.
+  * @return bool True if the network meets the criteria for large. False otherwise.
+  */
+ function wp_is_large_network( $using = 'sites' ) {
+ 	if ( 'users' == $using ) {
+ 		$count = get_user_count();
+ 		return apply_filters( 'wp_is_large_network', $count > 10000, 'users', $count );
+ 	}
+ 
+ 	$count = get_blog_count();
+ 	return apply_filters( 'wp_is_large_network', $count > 10000, 'sites', $count );
+ }
  ?>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/nav-menu.php ./wordpress-3.3/wp-admin/includes/nav-menu.php
*** ./wordpress-3.2.1/wp-admin/includes/nav-menu.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/nav-menu.php	2011-10-28 10:48:44.000000000 -0500
***************
*** 88,94 ****
  					<span class="item-title"><?php echo esc_html( $title ); ?></span>
  					<span class="item-controls">
  						<span class="item-type"><?php echo esc_html( $item->type_label ); ?></span>
! 						<span class="item-order">
  							<a href="<?php
  								echo wp_nonce_url(
  									add_query_arg(
--- 88,94 ----
  					<span class="item-title"><?php echo esc_html( $title ); ?></span>
  					<span class="item-controls">
  						<span class="item-type"><?php echo esc_html( $item->type_label ); ?></span>
! 						<span class="item-order hide-if-js">
  							<a href="<?php
  								echo wp_nonce_url(
  									add_query_arg(
***************
*** 115,121 ****
  								);
  							?>" class="item-move-down"><abbr title="<?php esc_attr_e('Move down'); ?>">&#8595;</abbr></a>
  						</span>
! 						<a class="item-edit" id="edit-<?php echo $item_id; ?>" title="<?php _e('Edit Menu Item'); ?>" href="<?php
  							echo ( isset( $_GET['edit-menu-item'] ) && $item_id == $_GET['edit-menu-item'] ) ? admin_url( 'nav-menus.php' ) : add_query_arg( 'edit-menu-item', $item_id, remove_query_arg( $removed_args, admin_url( 'nav-menus.php#menu-item-settings-' . $item_id ) ) );
  						?>"><?php _e( 'Edit Menu Item' ); ?></a>
  					</span>
--- 115,121 ----
  								);
  							?>" class="item-move-down"><abbr title="<?php esc_attr_e('Move down'); ?>">&#8595;</abbr></a>
  						</span>
! 						<a class="item-edit" id="edit-<?php echo $item_id; ?>" title="<?php esc_attr_e('Edit Menu Item'); ?>" href="<?php
  							echo ( isset( $_GET['edit-menu-item'] ) && $item_id == $_GET['edit-menu-item'] ) ? admin_url( 'nav-menus.php' ) : add_query_arg( 'edit-menu-item', $item_id, remove_query_arg( $removed_args, admin_url( 'nav-menus.php#menu-item-settings-' . $item_id ) ) );
  						?>"><?php _e( 'Edit Menu Item' ); ?></a>
  					</span>
***************
*** 143,155 ****
  						<input type="text" id="edit-menu-item-attr-title-<?php echo $item_id; ?>" class="widefat edit-menu-item-attr-title" name="menu-item-attr-title[<?php echo $item_id; ?>]" value="<?php echo esc_attr( $item->post_excerpt ); ?>" />
  					</label>
  				</p>
! 				<p class="field-link-target description description-thin">
  					<label for="edit-menu-item-target-<?php echo $item_id; ?>">
! 						<?php _e( 'Link Target' ); ?><br />
! 						<select id="edit-menu-item-target-<?php echo $item_id; ?>" class="widefat edit-menu-item-target" name="menu-item-target[<?php echo $item_id; ?>]">
! 							<option value="" <?php selected( $item->target, ''); ?>><?php _e('Same window or tab'); ?></option>
! 							<option value="_blank" <?php selected( $item->target, '_blank'); ?>><?php _e('New window or tab'); ?></option>
! 						</select>
  					</label>
  				</p>
  				<p class="field-css-classes description description-thin">
--- 143,152 ----
  						<input type="text" id="edit-menu-item-attr-title-<?php echo $item_id; ?>" class="widefat edit-menu-item-attr-title" name="menu-item-attr-title[<?php echo $item_id; ?>]" value="<?php echo esc_attr( $item->post_excerpt ); ?>" />
  					</label>
  				</p>
! 				<p class="field-link-target description">
  					<label for="edit-menu-item-target-<?php echo $item_id; ?>">
! 						<input type="checkbox" id="edit-menu-item-target-<?php echo $item_id; ?>" value="_blank" name="menu-item-target[<?php echo $item_id; ?>]"<?php checked( $item->target, '_blank' ); ?> />
! 						<?php _e( 'Open link in a new window/tab' ); ?>
  					</label>
  				</p>
  				<p class="field-css-classes description description-thin">
***************
*** 340,346 ****
  			while ( have_posts() ) {
  				the_post();
  				if ( 'markup' == $response_format ) {
! 					echo walk_nav_menu_tree( array_map('wp_setup_nav_menu_item', array( get_post( get_the_ID() ) ) ), 0, (object) $args );
  				} elseif ( 'json' == $response_format ) {
  					echo json_encode(
  						array(
--- 337,344 ----
  			while ( have_posts() ) {
  				the_post();
  				if ( 'markup' == $response_format ) {
! 					$var_by_ref = get_the_ID();
! 					echo walk_nav_menu_tree( array_map('wp_setup_nav_menu_item', array( get_post( $var_by_ref ) ) ), 0, (object) $args );
  				} elseif ( 'json' == $response_format ) {
  					echo json_encode(
  						array(
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/includes/plugin-install.php ./wordpress-3.3/wp-admin/includes/plugin-install.php
*** ./wordpress-3.2.1/wp-admin/includes/plugin-install.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/includes/plugin-install.php	2011-11-01 23:14:14.000000000 -0500
***************
*** 12,18 ****
   * It is possible for a plugin to override the Plugin API result with three
   * filters. Assume this is for plugins, which can extend on the Plugin Info to
   * offer more choices. This is very powerful and must be used with care, when
!  * overridding the filters.
   *
   * The first filter, 'plugins_api_args', is for the args and gives the action as
   * the second parameter. The hook for 'plugins_api_args' must ensure that an
--- 12,18 ----
   * It is possible for a plugin to override the Plugin API result with three
   * filters. Assume this is for plugins, which can extend on the Plugin Info to
   * offer more choices. This is very powerful and must be used with care, when
!  * overriding the filters.
   *
   * The first filter, 'plugins_api_args', is for the args and gives the action as
   * the second parameter. The hook for 'plugins_api_args' must ensure that an
***************
*** 35,41 ****
  		$args->per_page = 24;
  
  	// Allows a plugin to override the WordPress.org API entirely.
! 	// Use the filter 'plugins_api_result' to mearly add results.
  	// Please ensure that a object is returned from the following filters.
  	$args = apply_filters('plugins_api_args', $args, $action);
  	$res = apply_filters('plugins_api', false, $action, $args);
--- 35,41 ----
  		$args->per_page = 24;
  
  	// Allows a plugin to override the WordPress.org API entirely.
! 	// Use the filter 'plugins_api_result' to merely add results.
  	// Please ensure that a object is returned from the following filters.
  	$args = apply_filters('plugins_api_args', $args, $action);
  	$res = apply_filters('plugins_api', false, $action, $args);
***************
*** 81,87 ****
  
  function install_dashboard() {
  	?>
! 	<p><?php _e('Plugins extend and expand the functionality of WordPress. You may automatically install plugins from the <a href="http://wordpress.org/extend/plugins/">WordPress Plugin Directory</a> or upload a plugin in .zip format via this page.') ?></p>
  
  	<h4><?php _e('Search') ?></h4>
  	<p class="install-help"><?php _e('Search for plugins by keyword, author, or tag.') ?></p>
--- 81,87 ----
  
  function install_dashboard() {
  	?>
! 	<p><?php printf( __( 'Plugins extend and expand the functionality of WordPress. You may automatically install plugins from the <a href="http://wordpress.org/extend/plugins/">WordPress Plugin Directory</a> or upload a plugin in .zip format via <a href="%s">this page</a>.' ), self_admin_url( 'plugin-install.php?tab=upload' ) ); ?></p>
  
  	<h4><?php _e('Search') ?></h4>
  	<p class="install-help"><?php _e('Search for plugins by keyword, author, or tag.') ?></p>
***************
*** 97,103 ****
  	if ( is_wp_error($api_tags) ) {
  		echo $api_tags->get_error_message();
  	} else {
! 		//Set up the tags in a way which can be interprated by wp_generate_tag_cloud()
  		$tags = array();
  		foreach ( (array)$api_tags as $tag )
  			$tags[ $tag['name'] ] = (object) array(
--- 97,103 ----
  	if ( is_wp_error($api_tags) ) {
  		echo $api_tags->get_error_message();
  	} else {
! 		//Set up the tags in a way which can be interpreted by wp_generate_tag_cloud()
  		$tags = array();
  		foreach ( (array)$api_tags as $tag )
  			$tags[ $tag['name'] ] = (object) array(
***************
*** 105,111 ****
  									'name' => $tag['name'],
  									'id' => sanitize_title_with_dashes($tag['name']),
  									'count' => $tag['count'] );
! 		echo wp_generate_tag_cloud($tags, array( 'single_text' => __('%d plugin'), 'multiple_text' => __('%d plugins') ) );
  	}
  	echo '</p><br class="clear" />';
  }
--- 105,111 ----
  									'name' => $tag['name'],
  									'id' => sanitize_title_with_dashes($tag['name']),
  									'count' => $tag['count'] );
! 		echo wp_generate_tag_cloud($tags, array( 'single_text' => __('%s plugin'), 'multiple_text' => __('%s plugins') ) );
  	}
  	echo '</p><br class="clear" />';
  }
***************
*** 175,181 ****
   * @since 3.0.0
   */
  function install_plugin_install_status($api, $loop = false) {
! 	// this function is called recursivly, $loop prevents futhur loops.
  	if ( is_array($api) )
  		$api = (object) $api;
  
--- 175,181 ----
   * @since 3.0.0
   */
  function install_plugin_install_status($api, $loop = false) {
! 	// this function is called recursively, $loop prevents further loops.
  	if ( is_array($api) )
  		$api = (object) $api;
  
***************
*** 254,261 ****
  	//Sanitize HTML
  	foreach ( (array)$api->sections as $section_name => $content )
  		$api->sections[$section_name] = wp_kses($content, $plugins_allowedtags);
! 	foreach ( array('version', 'author', 'requires', 'tested', 'homepage', 'downloaded', 'slug') as $key )
! 		$api->$key = wp_kses($api->$key, $plugins_allowedtags);
  
  	$section = isset($_REQUEST['section']) ? stripslashes( $_REQUEST['section'] ) : 'description'; //Default to the Description tab, Do not translate, API returns English.
  	if ( empty($section) || ! isset($api->sections[ $section ]) )
--- 254,263 ----
  	//Sanitize HTML
  	foreach ( (array)$api->sections as $section_name => $content )
  		$api->sections[$section_name] = wp_kses($content, $plugins_allowedtags);
! 	foreach ( array( 'version', 'author', 'requires', 'tested', 'homepage', 'downloaded', 'slug' ) as $key ) {
! 		if ( isset( $api->$key ) )
! 			$api->$key = wp_kses( $api->$key, $plugins_allowedtags );
! 	}
  
  	$section = isset($_REQUEST['section']) ? stripslashes( $_REQUEST['section'] ) : 'description'; //Default to the Description tab, Do not translate, API returns English.
  	if ( empty($section) || ! isset($api->sections[ $section ]) )
***************
*** 327,337 ****
  		<h2><?php _e('Average Rating') ?></h2>
  		<div class="star-holder" title="<?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?>">
  			<div class="star star-rating" style="width: <?php echo esc_attr($api->rating) ?>px"></div>
! 			<div class="star star5"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('5 stars') ?>" /></div>
! 			<div class="star star4"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('4 stars') ?>" /></div>
! 			<div class="star star3"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('3 stars') ?>" /></div>
! 			<div class="star star2"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('2 stars') ?>" /></div>
! 			<div class="star star1"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php _e('1 star') ?>" /></div>
  		</div>
  		<small><?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?></small>
  		<?php endif; ?>
--- 329,339 ----
  		<h2><?php _e('Average Rating') ?></h2>
  		<div class="star-holder" title="<?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?>">
  			<div class="star star-rating" style="width: <?php echo esc_attr($api->rating) ?>px"></div>
! 			<div class="star star5"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('5 stars') ?>" /></div>
! 			<div class="star star4"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('4 stars') ?>" /></div>
! 			<div class="star star3"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('3 stars') ?>" /></div>
! 			<div class="star star2"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('2 stars') ?>" /></div>
! 			<div class="star star1"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('1 star') ?>" /></div>
  		</div>
  		<small><?php printf(_n('(based on %s rating)', '(based on %s ratings)', $api->num_ratings), number_format_i18n($api->num_ratings)); ?></small>
  		<?php endif; ?>
